package org.jeecg.modules.fbsAbnormalWorkingHours.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursDescribe;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * @Description: 异常工时描述
 * @author： jeecg-boot
 * @date：   2020-10-14
 * @version： V1.0
 */
public interface FbsAbnormalWorkingHoursDescribeMapper extends BaseMapper<FbsAbnormalWorkingHoursDescribe> {
    /**
    * @Author chenchuang
    * @Description //TODO 制造看板：月制程质量异常
    * @Date 2020/10/28 15:33
    * @Param []
    * @return java.util.List<org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursDescribe>
    */
  List<FbsAbnormalWorkingHoursDescribe>  getMonthExceptionByCategory();

  /**
  * @Author chenchuang
  * @Description //TODO 明细导出数据
  * @Date 2020/11/18 16:05
  * @Param []
  * @return java.util.List<org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursDescribe>
  */
  List<FbsAbnormalWorkingHoursDescribe> getListAndMain(@Param("fbsAbnormalWorkingHoursDescribe") FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe);

  /**
  * @Author chenchuang
  * @Description //TODO 月制程良率
  * @Date 2020/12/8 16:22
  * @Param []
  * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
  */
  List<Map<String,Object>>  getMonthExceptionByCategoryTwo();
}
