package org.jeecg.modules.fbsPuArrivalvouch.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.jeecg.modules.fbsPuArrivalvouch.entity.FbsArrivalVouchs;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * @Description: 采购到货退货单主表（表体）
 * @author： jeecg-boot
 * @date：   2020-10-21
 * @version： V1.0
 */
public interface FbsArrivalVouchsMapper extends BaseMapper<FbsArrivalVouchs> {
    /**
     * 未来3天的到货计划
     * @return
     */
    public List<FbsArrivalVouchs> getWillArriveList();

    /**
     * 近6个月质量目标合格率比较
     * @return
     */
    public List<Map<String,Object>> getLastSixMonthQualityTargetCompare();

    /**
     * 获取百分比
     * @return
     */
    public int selectPercentage();

}
