package org.jeecg.modules.pulldate.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 接口获取时间
 * @author： jeecg-boot
 * @date：   2022-02-17
 * @version： V1.0
 */
@Data
@TableName("pull_date")
public class PullDate implements Serializable {
    private static final long serialVersionUID = 1L;
    
	/**最后查询时间*/
	@Excel(name = "最后查询时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date endTime;
	/**主键*/
	@TableId(type = IdType.UUID)
	private String id;
}
