package org.jeecg.modules.pulldate.service.impl;

import org.jeecg.modules.pulldate.entity.PullDate;
import org.jeecg.modules.pulldate.mapper.PullDateMapper;
import org.jeecg.modules.pulldate.service.IPullDateService;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.Date;

/**
 * @Description: 接口获取时间
 * @author： jeecg-boot
 * @date：   2022-02-17
 * @version： V1.0
 */
@Service
public class PullDateServiceImpl extends ServiceImpl<PullDateMapper, PullDate> implements IPullDateService {

    @Override
    public Date getMaxEndTime() {
        return this.baseMapper.getMaxEndTime();
    }
}
