package org.jeecg.modules.fbsMomOrder.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.jeecg.modules.fbsMomOrder.entity.FbsMomOrder;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * @Description: 生产订单
 * @author： jeecg-boot
 * @date：   2020-10-16
 * @version： V1.0
 */
public interface FbsMomOrderMapper extends BaseMapper<FbsMomOrder> {

    public List<Map<String,Object>> getEsopTaskList();

    /**
    * @Author chenchuang
    * @Description //TODO 根据批号查询入库单是否已存在
    * @Date 2021/1/12 10:05
    * @Param [cBatch]
    * @return java.lang.Integer
    */
    public List<Map<String,String>> getIsOnlyByCbatch(@Param("list")List<String> cBatchList);
}
