package org.jeecg.modules.fbsMomOrder.service;

import org.jeecg.modules.fbsMomOrder.entity.FbsMomOrder;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
 * @Description: 生产订单
 * @author： jeecg-boot
 * @date：   2020-10-16
 * @version： V1.0
 */
public interface IFbsMomOrderService extends IService<FbsMomOrder> {
    public List<Map<String,Object>> getEsopTaskList();

    /**
    * @Author chenchuang
    * @Description //TODO 根据批号查询入库单是否已存在
    * @Date 2021/1/12 10:08
    * @Param [cBatch]
    * @return java.lang.Integer
    */
    public List<Map<String,String>> getIsOnlyByCbatch(List<String> cBatchList);

    /**
    * @Author chenchuang
    * @Description //TODO 获取Sap生产订单数据以及领料数据与工序
    * @Date 2022/1/20 21:15
    * @Param []
    * @return void
    */
    public void getPullSapMomOrderAll(Long start,Long end);
}
