package org.jeecg.modules.fbsPuArrivalvouch.service;

import org.jeecg.modules.fbsPuArrivalvouch.entity.FbsArrivalVouchs;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
 * @Description: 采购到货退货单主表（表体）
 * @author： jeecg-boot
 * @date：   2020-10-21
 * @version： V1.0
 */
public interface IFbsArrivalVouchsService extends IService<FbsArrivalVouchs> {

    public List<FbsArrivalVouchs> getWillArriveList();

    /**
    * @Author chenchuang
    * @Description //TODO 品质看板：近六个月合格率U8
    * @Date 2020/11/10 11:19
    * @Param []
    * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
    */
    public List<Map<String,Object>> getLastSixMonthQualityTargetCompare();


}
